/*
 * Soubor:  msort.c
 * Datum:   3.1.2011 20:34
 * Autor:   Marek Nožka, nozka <@t> spseol <d.t> cz;
 *          cenné rady poskytl Jan Outrata
 * Licence: GNU/GPL 
 * Úloha:   Testování rychlosti řadících algoritmů
 * Popis:   V programu je použit simbol MSORT, který se pří kompilaci (gcc -D)
 *          nahradí jménem funkce z knihovny libsort.c. Tento program měří čas, 
 *          za jak dlouho se pole seřadí.
 */

/////////////////////////////////////////////////////
#include <sys/time.h>
#include <stdlib.h>
#include <stdio.h>

#include "libsort.h"
/////////////////////////////////////////////////////

/**
 * Hlavní program.
 */
int main(void)
{
    int array[COUNT];
    initgen();
    generate(0,COUNT-1, array);
    //show(0,COUNT-1, array);

    struct timeval time_start, time_end;
    gettimeofday(&time_start, NULL);

    MSORT(0, COUNT - 1, array);

    gettimeofday(&time_end, NULL);

    int usec_less = (time_end.tv_usec < time_start.tv_usec) ? 1 : 0;
    printf("time: %li.%06li s ", time_end.tv_sec - time_start.tv_sec
           - usec_less, usec_less * 1000000 + time_end.tv_usec -
           time_start.tv_usec);

    printf("-- %s\n", control(0,COUNT-1, array) ? "OK :-)" : " Ups >;(" );
    //show(0,COUNT-1, array);

    return 0;
}
